Index: /branches/UKMO/dev_r5518_medusa_chg_trc_bio_medusa/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90
===================================================================
--- /branches/UKMO/dev_r5518_medusa_chg_trc_bio_medusa/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 7885)
+++ /branches/UKMO/dev_r5518_medusa_chg_trc_bio_medusa/NEMOGCM/NEMO/TOP_SRC/MEDUSA/trcbio_medusa.F90	(revision 7886)
@@ -3733,82 +3707,82 @@
                !! alkalinity
                fa_prod = 0.0  &
-                 + (2.0 * freminca)                                                   ! CaCO3 dissolution
+                 + (2.0 * freminca(ji,jj))                                                   ! CaCO3 dissolution
                fa_cons = 0.0  &
-                 - (2.0 * ftempca)                                                    ! CaCO3 production
+                 - (2.0 * ftempca(ji,jj))                                                    ! CaCO3 production
                !! 
                !! riverine flux
                if ( jriver_alk .gt. 0 ) then
-                  f_riv_loc_alk = f_riv_alk(ji,jj) * friver_dep(jk,jmbathy) / fthk
-                  fa_prod = fa_prod + f_riv_loc_alk
+                  f_riv_loc_alk(ji,jj) = f_riv_alk(ji,jj) * friver_dep(jk,mbathy(ji,jj)) / fse3t(ji,jj,jk)
+                  fa_prod = fa_prod + f_riv_loc_alk(ji,jj)
                endif
                !!  
                !! benthic remineralisation
-               if (jk.eq.jmbathy .and. jinorgben.eq.1 .and. ibenthic.eq.1) then
-                  fa_prod = fa_prod + (2.0 * f_benout_ca(ji,jj) / fthk)
+               if (jk.eq.mbathy(ji,jj) .and. jinorgben.eq.1 .and. ibenthic.eq.1) then
+                  fa_prod = fa_prod + (2.0 * f_benout_ca(ji,jj) / fse3t(ji,jj,jk))
                endif
                !!
-               btra(jpalk) = b0 * ( &
+               btra(ji,jj,jpalk) = b0 * ( &
                  fa_prod + fa_cons )
                !!
                !!----------------------------------------------------------------------
                !! oxygen (has protection at low O2 concentrations; OCMIP-2 style)
-               fo2_prod = 0.0 &
-                 + (xthetanit * fprn * zphn)                                      & ! Pn primary production, N
-                 + (xthetanit * fprd * zphd)                                      & ! Pd primary production, N
-                 + (xthetarem * xthetapn * fprn * zphn)                           & ! Pn primary production, C
-                 + (xthetarem * xthetapd * fprd * zphd)                             ! Pd primary production, C
-               fo2_ncons = 0.0 &
-                 - (xthetanit * xphi * fgmipn)                                    & ! Pn messy feeding remin., N
-                 - (xthetanit * xphi * fgmid)                                     & ! D  messy feeding remin., N
-                 - (xthetanit * xphi * fgmepn)                                    & ! Pn messy feeding remin., N
-                 - (xthetanit * xphi * fgmepd)                                    & ! Pd messy feeding remin., N
-                 - (xthetanit * xphi * fgmezmi)                                   & ! Zi messy feeding remin., N
-                 - (xthetanit * xphi * fgmed)                                     & ! D  messy feeding remin., N
-                 - (xthetanit * fmiexcr)                                          & ! microzoo excretion, N
-                 - (xthetanit * fmeexcr)                                          & ! mesozoo  excretion, N
-                 - (xthetanit * fdd)                                              & ! slow detritus remin., N 
-                 - (xthetanit * freminn)                                          & ! fast detritus remin., N
-                 - (xthetanit * fdpn2)                                            & ! Pn  losses, N
-                 - (xthetanit * fdpd2)                                            & ! Pd  losses, N
-                 - (xthetanit * fdzmi2)                                           & ! Zmi losses, N
-                 - (xthetanit * fdzme2)                                             ! Zme losses, N
+               fo2_prod(ji,jj) = 0.0 &
+                 + (xthetanit * fprn(ji,jj) * zphn(ji,jj))                                      & ! Pn primary production, N
+                 + (xthetanit * fprd(ji,jj) * zphd(ji,jj))                                      & ! Pd primary production, N
+                 + (xthetarem * xthetapn * fprn(ji,jj) * zphn(ji,jj))                           & ! Pn primary production, C
+                 + (xthetarem * xthetapd * fprd(ji,jj) * zphd(ji,jj))                             ! Pd primary production, C
+               fo2_ncons(ji,jj) = 0.0 &
+                 - (xthetanit * xphi * fgmipn(ji,jj))                                    & ! Pn messy feeding remin., N
+                 - (xthetanit * xphi * fgmid(ji,jj))                                     & ! D  messy feeding remin., N
+                 - (xthetanit * xphi * fgmepn(ji,jj))                                    & ! Pn messy feeding remin., N
+                 - (xthetanit * xphi * fgmepd(ji,jj))                                    & ! Pd messy feeding remin., N
+                 - (xthetanit * xphi * fgmezmi(ji,jj))                                   & ! Zi messy feeding remin., N
+                 - (xthetanit * xphi * fgmed(ji,jj))                                     & ! D  messy feeding remin., N
+                 - (xthetanit * fmiexcr(ji,jj))                                          & ! microzoo excretion, N
+                 - (xthetanit * fmeexcr(ji,jj))                                          & ! mesozoo  excretion, N
+                 - (xthetanit * fdd(ji,jj))                                              & ! slow detritus remin., N 
+                 - (xthetanit * freminn(ji,jj))                                          & ! fast detritus remin., N
+                 - (xthetanit * fdpn2(ji,jj))                                            & ! Pn  losses, N
+                 - (xthetanit * fdpd2(ji,jj))                                            & ! Pd  losses, N
+                 - (xthetanit * fdzmi2(ji,jj))                                           & ! Zmi losses, N
+                 - (xthetanit * fdzme2(ji,jj))                                             ! Zme losses, N
                !!  
                !! benthic remineralisation
-               if (jk.eq.jmbathy .and. jorgben.eq.1 .and. ibenthic.eq.1) then
-                  fo2_ncons = fo2_ncons - (xthetanit * f_benout_n(ji,jj) / fthk)
+               if (jk.eq.mbathy(ji,jj) .and. jorgben.eq.1 .and. ibenthic.eq.1) then
+                  fo2_ncons(ji,jj) = fo2_ncons(ji,jj) - (xthetanit * f_benout_n(ji,jj) / fse3t(ji,jj,jk))
                endif
-               fo2_ccons = 0.0 &
-                 - (xthetarem * xthetapn * xphi * fgmipn)                         & ! Pn messy feeding remin., C
-                 - (xthetarem * xphi * fgmidc)                                    & ! D  messy feeding remin., C
-                 - (xthetarem * xthetapn * xphi * fgmepn)                         & ! Pn messy feeding remin., C
-                 - (xthetarem * xthetapd * xphi * fgmepd)                         & ! Pd messy feeding remin., C
-                 - (xthetarem * xthetazmi * xphi * fgmezmi)                       & ! Zi messy feeding remin., C
-                 - (xthetarem * xphi * fgmedc)                                    & ! D  messy feeding remin., C
-                 - (xthetarem * fmiresp)                                          & ! microzoo respiration, C
-                 - (xthetarem * fmeresp)                                          & ! mesozoo  respiration, C
-                 - (xthetarem * fddc)                                             & ! slow detritus remin., C
-                 - (xthetarem * freminc)                                          & ! fast detritus remin., C
-                 - (xthetarem * xthetapn * fdpn2)                                 & ! Pn  losses, C
-                 - (xthetarem * xthetapd * fdpd2)                                 & ! Pd  losses, C
-                 - (xthetarem * xthetazmi * fdzmi2)                               & ! Zmi losses, C
-                 - (xthetarem * xthetazme * fdzme2)                                 ! Zme losses, C
+               fo2_ccons(ji,jj) = 0.0 &
+                 - (xthetarem * xthetapn * xphi * fgmipn(ji,jj))                         & ! Pn messy feeding remin., C
+                 - (xthetarem * xphi * fgmidc(ji,jj))                                    & ! D  messy feeding remin., C
+                 - (xthetarem * xthetapn * xphi * fgmepn(ji,jj))                         & ! Pn messy feeding remin., C
+                 - (xthetarem * xthetapd * xphi * fgmepd(ji,jj))                         & ! Pd messy feeding remin., C
+                 - (xthetarem * xthetazmi * xphi * fgmezmi(ji,jj))                       & ! Zi messy feeding remin., C
+                 - (xthetarem * xphi * fgmedc(ji,jj))                                    & ! D  messy feeding remin., C
+                 - (xthetarem * fmiresp(ji,jj))                                          & ! microzoo respiration, C
+                 - (xthetarem * fmeresp(ji,jj))                                          & ! mesozoo  respiration, C
+                 - (xthetarem * fddc(ji,jj))                                             & ! slow detritus remin., C
+                 - (xthetarem * freminc(ji,jj))                                          & ! fast detritus remin., C
+                 - (xthetarem * xthetapn * fdpn2(ji,jj))                                 & ! Pn  losses, C
+                 - (xthetarem * xthetapd * fdpd2(ji,jj))                                 & ! Pd  losses, C
+                 - (xthetarem * xthetazmi * fdzmi2(ji,jj))                               & ! Zmi losses, C
+                 - (xthetarem * xthetazme * fdzme2(ji,jj))                                 ! Zme losses, C
                !!  
                !! benthic remineralisation
-               if (jk.eq.jmbathy .and. jorgben.eq.1 .and. ibenthic.eq.1) then
-                  fo2_ccons = fo2_ccons - (xthetarem * f_benout_c(ji,jj) / fthk)
+               if (jk.eq.mbathy(ji,jj) .and. jorgben.eq.1 .and. ibenthic.eq.1) then
+                  fo2_ccons(ji,jj) = fo2_ccons(ji,jj) - (xthetarem * f_benout_c(ji,jj) / fse3t(ji,jj,jk))
                endif
-               fo2_cons = fo2_ncons + fo2_ccons
+               fo2_cons(ji,jj) = fo2_ncons(ji,jj) + fo2_ccons(ji,jj)
                !!
                !! is this a suboxic zone?
-               if (zoxy.lt.xo2min) then  ! deficient O2; production fluxes only
-                  btra(jpoxy) = b0 * ( &
-                    fo2_prod )
-                  foxy_prod(ji,jj) = foxy_prod(ji,jj) + ( fthk * fo2_prod )
-                  foxy_anox(ji,jj) = foxy_anox(ji,jj) + ( fthk * fo2_cons )
+               if (zoxy(ji,jj).lt.xo2min) then  ! deficient O2; production fluxes only
+                  btra(ji,jj,jpoxy) = b0 * ( &
+                    fo2_prod(ji,jj) )
+                  foxy_prod(ji,jj) = foxy_prod(ji,jj) + ( fse3t(ji,jj,jk) * fo2_prod(ji,jj) )
+                  foxy_anox(ji,jj) = foxy_anox(ji,jj) + ( fse3t(ji,jj,jk) * fo2_cons(ji,jj) )
                else                      ! sufficient O2; production + consumption fluxes
-                  btra(jpoxy) = b0 * ( &
-                    fo2_prod + fo2_cons )
-                  foxy_prod(ji,jj) = foxy_prod(ji,jj) + ( fthk * fo2_prod )
-                  foxy_cons(ji,jj) = foxy_cons(ji,jj) + ( fthk * fo2_cons )
+                  btra(ji,jj,jpoxy) = b0 * ( &
+                    fo2_prod(ji,jj) + fo2_cons(ji,jj) )
+                  foxy_prod(ji,jj) = foxy_prod(ji,jj) + ( fse3t(ji,jj,jk) * fo2_prod(ji,jj) )
+                  foxy_cons(ji,jj) = foxy_cons(ji,jj) + ( fse3t(ji,jj,jk) * fo2_cons(ji,jj) )
                endif
                !!
@@ -3817,8 +3791,8 @@
                   !!
                   !! CO2 flux
-                  btra(jpdic) = btra(jpdic) + (b0 * f_co2flux)
+                  btra(ji,jj,jpdic) = btra(ji,jj,jpdic) + (b0 * f_co2flux(ji,jj))
                   !!
                   !! O2 flux (mol/m3/s -> mmol/m3/d)
-                  btra(jpoxy) = btra(jpoxy) + (b0 * f_o2flux)
+                  btra(ji,jj,jpoxy) = btra(ji,jj,jpoxy) + (b0 * f_o2flux(ji,jj))
                endif
 # endif
@@ -3828,20 +3802,20 @@
                if (idf.eq.1.AND.idfval.eq.1) then
                   IF (lwp) write (numout,*) '------------------------------'
-                  IF (lwp) write (numout,*) 'btra(jpchn)(',jk,')  = ', btra(jpchn)
-                  IF (lwp) write (numout,*) 'btra(jpchd)(',jk,')  = ', btra(jpchd)
-                  IF (lwp) write (numout,*) 'btra(jpphn)(',jk,')  = ', btra(jpphn)
-                  IF (lwp) write (numout,*) 'btra(jpphd)(',jk,')  = ', btra(jpphd)
-                  IF (lwp) write (numout,*) 'btra(jppds)(',jk,')  = ', btra(jppds)
-                  IF (lwp) write (numout,*) 'btra(jpzmi)(',jk,')  = ', btra(jpzmi)
-                  IF (lwp) write (numout,*) 'btra(jpzme)(',jk,')  = ', btra(jpzme)
-                  IF (lwp) write (numout,*) 'btra(jpdet)(',jk,')  = ', btra(jpdet)
-                  IF (lwp) write (numout,*) 'btra(jpdin)(',jk,')  = ', btra(jpdin)
-                  IF (lwp) write (numout,*) 'btra(jpsil)(',jk,')  = ', btra(jpsil)
-                  IF (lwp) write (numout,*) 'btra(jpfer)(',jk,')  = ', btra(jpfer)
+                  IF (lwp) write (numout,*) 'btra(ji,jj,jpchn)(',jk,')  = ', btra(ji,jj,jpchn)
+                  IF (lwp) write (numout,*) 'btra(ji,jj,jpchd)(',jk,')  = ', btra(ji,jj,jpchd)
+                  IF (lwp) write (numout,*) 'btra(ji,jj,jpphn)(',jk,')  = ', btra(ji,jj,jpphn)
+                  IF (lwp) write (numout,*) 'btra(ji,jj,jpphd)(',jk,')  = ', btra(ji,jj,jpphd)
+                  IF (lwp) write (numout,*) 'btra(ji,jj,jppds)(',jk,')  = ', btra(ji,jj,jppds)
+                  IF (lwp) write (numout,*) 'btra(ji,jj,jpzmi)(',jk,')  = ', btra(ji,jj,jpzmi)
+                  IF (lwp) write (numout,*) 'btra(ji,jj,jpzme)(',jk,')  = ', btra(ji,jj,jpzme)
+                  IF (lwp) write (numout,*) 'btra(ji,jj,jpdet)(',jk,')  = ', btra(ji,jj,jpdet)
+                  IF (lwp) write (numout,*) 'btra(ji,jj,jpdin)(',jk,')  = ', btra(ji,jj,jpdin)
+                  IF (lwp) write (numout,*) 'btra(ji,jj,jpsil)(',jk,')  = ', btra(ji,jj,jpsil)
+                  IF (lwp) write (numout,*) 'btra(ji,jj,jpfer)(',jk,')  = ', btra(ji,jj,jpfer)
 #  if defined key_roam
-                  IF (lwp) write (numout,*) 'btra(jpdtc)(',jk,')  = ', btra(jpdtc)
-                  IF (lwp) write (numout,*) 'btra(jpdic)(',jk,')  = ', btra(jpdic)
-                  IF (lwp) write (numout,*) 'btra(jpalk)(',jk,')  = ', btra(jpalk)
-                  IF (lwp) write (numout,*) 'btra(jpoxy)(',jk,')  = ', btra(jpoxy)
+                  IF (lwp) write (numout,*) 'btra(ji,jj,jpdtc)(',jk,')  = ', btra(ji,jj,jpdtc)
+                  IF (lwp) write (numout,*) 'btra(ji,jj,jpdic)(',jk,')  = ', btra(ji,jj,jpdic)
+                  IF (lwp) write (numout,*) 'btra(ji,jj,jpalk)(',jk,')  = ', btra(ji,jj,jpalk)
+                  IF (lwp) write (numout,*) 'btra(ji,jj,jpoxy)(',jk,')  = ', btra(ji,jj,jpoxy)
 #  endif
                endif
@@ -3854,22 +3828,22 @@
                !! === nitrogen ===
                fflx_n(ji,jj)  = fflx_n(ji,jj)  + &
-                  fthk * ( btra(jpphn) + btra(jpphd) + btra(jpzmi) + btra(jpzme) + btra(jpdet) + btra(jpdin) )
+                  fse3t(ji,jj,jk) * ( btra(ji,jj,jpphn) + btra(ji,jj,jpphd) + btra(ji,jj,jpzmi) + btra(ji,jj,jpzme) + btra(ji,jj,jpdet) + btra(ji,jj,jpdin) )
                !! === silicon ===
                fflx_si(ji,jj) = fflx_si(ji,jj) + &
-                  fthk * ( btra(jppds) + btra(jpsil) )
+                  fse3t(ji,jj,jk) * ( btra(ji,jj,jppds) + btra(ji,jj,jpsil) )
                !! === iron ===
                fflx_fe(ji,jj) = fflx_fe(ji,jj) + &
-                  fthk * ( ( xrfn * ( btra(jpphn) + btra(jpphd) + btra(jpzmi) + btra(jpzme) + btra(jpdet)) ) + btra(jpfer) )
+                  fse3t(ji,jj,jk) * ( ( xrfn * ( btra(ji,jj,jpphn) + btra(ji,jj,jpphd) + btra(ji,jj,jpzmi) + btra(ji,jj,jpzme) + btra(ji,jj,jpdet)) ) + btra(ji,jj,jpfer) )
 # if defined key_roam
                !! === carbon ===
                fflx_c(ji,jj)  = fflx_c(ji,jj)  + &
-                  fthk * ( (xthetapn * btra(jpphn)) + (xthetapd * btra(jpphd)) + &
-                  (xthetazmi * btra(jpzmi)) + (xthetazme * btra(jpzme)) + btra(jpdtc) + btra(jpdic) )
+                  fse3t(ji,jj,jk) * ( (xthetapn * btra(ji,jj,jpphn)) + (xthetapd * btra(ji,jj,jpphd)) + &
+                  (xthetazmi * btra(ji,jj,jpzmi)) + (xthetazme * btra(ji,jj,jpzme)) + btra(ji,jj,jpdtc) + btra(ji,jj,jpdic) )
                !! === alkalinity ===
                fflx_a(ji,jj)  = fflx_a(ji,jj)  + &
-                  fthk * ( btra(jpalk) )
+                  fse3t(ji,jj,jk) * ( btra(ji,jj,jpalk) )
                !! === oxygen ===
                fflx_o2(ji,jj) = fflx_o2(ji,jj) + &
-                  fthk * ( btra(jpoxy) )
+                  fse3t(ji,jj,jk) * ( btra(ji,jj,jpoxy) )
 # endif
 
@@ -3895,20 +3869,20 @@
 # endif               
                if (ibio_switch.eq.1) then
-                  tra(ji,jj,jk,jpchn) = tra(ji,jj,jk,jpchn) + (btra(jpchn) / 86400.)
-                  tra(ji,jj,jk,jpchd) = tra(ji,jj,jk,jpchd) + (btra(jpchd) / 86400.)
-                  tra(ji,jj,jk,jpphn) = tra(ji,jj,jk,jpphn) + (btra(jpphn) / 86400.)
-                  tra(ji,jj,jk,jpphd) = tra(ji,jj,jk,jpphd) + (btra(jpphd) / 86400.)
-                  tra(ji,jj,jk,jppds) = tra(ji,jj,jk,jppds) + (btra(jppds) / 86400.)
-                  tra(ji,jj,jk,jpzmi) = tra(ji,jj,jk,jpzmi) + (btra(jpzmi) / 86400.)
-                  tra(ji,jj,jk,jpzme) = tra(ji,jj,jk,jpzme) + (btra(jpzme) / 86400.)
-                  tra(ji,jj,jk,jpdet) = tra(ji,jj,jk,jpdet) + (btra(jpdet) / 86400.)
-                  tra(ji,jj,jk,jpdin) = tra(ji,jj,jk,jpdin) + (btra(jpdin) / 86400.)
-                  tra(ji,jj,jk,jpsil) = tra(ji,jj,jk,jpsil) + (btra(jpsil) / 86400.)
-                  tra(ji,jj,jk,jpfer) = tra(ji,jj,jk,jpfer) + (btra(jpfer) / 86400.)
+                  tra(ji,jj,jk,jpchn) = tra(ji,jj,jk,jpchn) + (btra(ji,jj,jpchn) / 86400.)
+                  tra(ji,jj,jk,jpchd) = tra(ji,jj,jk,jpchd) + (btra(ji,jj,jpchd) / 86400.)
+                  tra(ji,jj,jk,jpphn) = tra(ji,jj,jk,jpphn) + (btra(ji,jj,jpphn) / 86400.)
+                  tra(ji,jj,jk,jpphd) = tra(ji,jj,jk,jpphd) + (btra(ji,jj,jpphd) / 86400.)
+                  tra(ji,jj,jk,jppds) = tra(ji,jj,jk,jppds) + (btra(ji,jj,jppds) / 86400.)
+                  tra(ji,jj,jk,jpzmi) = tra(ji,jj,jk,jpzmi) + (btra(ji,jj,jpzmi) / 86400.)
+                  tra(ji,jj,jk,jpzme) = tra(ji,jj,jk,jpzme) + (btra(ji,jj,jpzme) / 86400.)
+                  tra(ji,jj,jk,jpdet) = tra(ji,jj,jk,jpdet) + (btra(ji,jj,jpdet) / 86400.)
+                  tra(ji,jj,jk,jpdin) = tra(ji,jj,jk,jpdin) + (btra(ji,jj,jpdin) / 86400.)
+                  tra(ji,jj,jk,jpsil) = tra(ji,jj,jk,jpsil) + (btra(ji,jj,jpsil) / 86400.)
+                  tra(ji,jj,jk,jpfer) = tra(ji,jj,jk,jpfer) + (btra(ji,jj,jpfer) / 86400.)
 # if defined key_roam
-                  tra(ji,jj,jk,jpdtc) = tra(ji,jj,jk,jpdtc) + (btra(jpdtc) / 86400.)
-                  tra(ji,jj,jk,jpdic) = tra(ji,jj,jk,jpdic) + (btra(jpdic) / 86400.)
-                  tra(ji,jj,jk,jpalk) = tra(ji,jj,jk,jpalk) + (btra(jpalk) / 86400.)
-                  tra(ji,jj,jk,jpoxy) = tra(ji,jj,jk,jpoxy) + (btra(jpoxy) / 86400.)
+                  tra(ji,jj,jk,jpdtc) = tra(ji,jj,jk,jpdtc) + (btra(ji,jj,jpdtc) / 86400.)
+                  tra(ji,jj,jk,jpdic) = tra(ji,jj,jk,jpdic) + (btra(ji,jj,jpdic) / 86400.)
+                  tra(ji,jj,jk,jpalk) = tra(ji,jj,jk,jpalk) + (btra(ji,jj,jpalk) / 86400.)
+                  tra(ji,jj,jk,jpoxy) = tra(ji,jj,jk,jpoxy) + (btra(ji,jj,jpoxy) / 86400.)
 # endif
                endif               
@@ -3916,33 +3890,33 @@
                !! AXY (18/11/16): CMIP6 diagnostics
                IF( med_diag%FBDDTALK%dgsave )  THEN
-                  fbddtalk(ji,jj)  =  fbddtalk(ji,jj)  + (btra(jpalk) * fthk)
+                  fbddtalk(ji,jj)  =  fbddtalk(ji,jj)  + (btra(ji,jj,jpalk) * fse3t(ji,jj,jk))
                ENDIF
                IF( med_diag%FBDDTDIC%dgsave )  THEN
-                  fbddtdic(ji,jj)  =  fbddtdic(ji,jj)  + (btra(jpdic) * fthk)
+                  fbddtdic(ji,jj)  =  fbddtdic(ji,jj)  + (btra(ji,jj,jpdic) * fse3t(ji,jj,jk))
                ENDIF
                IF( med_diag%FBDDTDIFE%dgsave ) THEN
-                  fbddtdife(ji,jj) =  fbddtdife(ji,jj) + (btra(jpfer) * fthk)
+                  fbddtdife(ji,jj) =  fbddtdife(ji,jj) + (btra(ji,jj,jpfer) * fse3t(ji,jj,jk))
                ENDIF
                IF( med_diag%FBDDTDIN%dgsave )  THEN
-                  fbddtdin(ji,jj)  =  fbddtdin(ji,jj)  + (btra(jpdin) * fthk)
+                  fbddtdin(ji,jj)  =  fbddtdin(ji,jj)  + (btra(ji,jj,jpdin) * fse3t(ji,jj,jk))
                ENDIF
                IF( med_diag%FBDDTDISI%dgsave ) THEN
-                  fbddtdisi(ji,jj) =  fbddtdisi(ji,jj) + (btra(jpsil) * fthk)
+                  fbddtdisi(ji,jj) =  fbddtdisi(ji,jj) + (btra(ji,jj,jpsil) * fse3t(ji,jj,jk))
                ENDIF
 	       !!
                IF( med_diag%BDDTALK3%dgsave )  THEN
-                  bddtalk3(ji,jj,jk)  =  btra(jpalk)
+                  bddtalk3(ji,jj,jk)  =  btra(ji,jj,jpalk)
                ENDIF
                IF( med_diag%BDDTDIC3%dgsave )  THEN
-                  bddtdic3(ji,jj,jk)  =  btra(jpdic)
+                  bddtdic3(ji,jj,jk)  =  btra(ji,jj,jpdic)
                ENDIF
                IF( med_diag%BDDTDIFE3%dgsave ) THEN
-                  bddtdife3(ji,jj,jk) =  btra(jpfer)
+                  bddtdife3(ji,jj,jk) =  btra(ji,jj,jpfer)
                ENDIF
                IF( med_diag%BDDTDIN3%dgsave )  THEN
-                  bddtdin3(ji,jj,jk)  =  btra(jpdin)
+                  bddtdin3(ji,jj,jk)  =  btra(ji,jj,jpdin)
                ENDIF
                IF( med_diag%BDDTDISI3%dgsave ) THEN
-                  bddtdisi3(ji,jj,jk) =  btra(jpsil)
+                  bddtdisi3(ji,jj,jk) =  btra(ji,jj,jpsil)
                ENDIF
 
@@ -3960,10 +3934,10 @@
                !!
                DO jn = 1,jptra
-                  fq0 = btra(jn)
+                  fq0 = btra(ji,jj,jn)
                   !! AXY (30/01/14): "isnan" problem on HECTOR
                   !! if (fq0 /= fq0 ) then
                   if ( ieee_is_nan( fq0 ) ) then
                      !! there's a NaN here
-                     if (lwp) write(numout,*) 'NAN detected in btra(', ji, ',', &
+                     if (lwp) write(numout,*) 'NAN detected in btra(ji,jj,', ji, ',', &
                      & jj, ',', jk, ',', jn, ') at time', kt
 		     CALL ctl_stop( 'trcbio_medusa, NAN in btra field' )
@@ -3993,7 +3967,7 @@
                !!----------------------------------------------------------------------
                !!
-               !! fnit0 = btra(jpphn) + btra(jpphd) + btra(jpzmi) + btra(jpzme) + btra(jpdet) + btra(jpdin)  ! + ftempn
-               !! fsil0 = btra(jppds) + btra(jpsil)                              ! + ftempsi
-               !! ffer0 = (xrfn * fnit0) + btra(jpfer)
+               !! fnit0 = btra(ji,jj,jpphn) + btra(ji,jj,jpphd) + btra(ji,jj,jpzmi) + btra(ji,jj,jpzme) + btra(ji,jj,jpdet) + btra(ji,jj,jpdin)  ! + ftempn(ji,jj)
+               !! fsil0 = btra(ji,jj,jppds) + btra(ji,jj,jpsil)                              ! + ftempsi(ji,jj)
+               !! ffer0 = (xrfn * fnit0) + btra(ji,jj,jpfer)
 # if defined key_roam
                !! fcar0 = 0.
@@ -4027,5 +4001,5 @@
                !!
                IF(lwp) WRITE(numout,*) ' MEDUSA does not support key_trc_diabio'
-               !!               trbio(ji,jj,jk, 1) = fprn
+               !!               trbio(ji,jj,jk, 1) = fprn(ji,jj)
 # endif
 
@@ -4041,14 +4015,14 @@
 #   endif
                   IF ( med_diag%PRN%dgsave ) THEN
-                      fprn2d(ji,jj) = fprn2d(ji,jj) + (fprn  * zphn * fthk) 
+                      fprn2d(ji,jj) = fprn2d(ji,jj) + (fprn(ji,jj)  * zphn(ji,jj) * fse3t(ji,jj,jk)) 
                   ENDIF
                   IF ( med_diag%MPN%dgsave ) THEN
-                      fdpn2d(ji,jj) = fdpn2d(ji,jj) + (fdpn         * fthk)
+                      fdpn2d(ji,jj) = fdpn2d(ji,jj) + (fdpn(ji,jj)         * fse3t(ji,jj,jk))
                   ENDIF
                   IF ( med_diag%PRD%dgsave ) THEN
-                      fprd2d(ji,jj) = fprd2d(ji,jj) + (fprd  * zphd * fthk)
+                      fprd2d(ji,jj) = fprd2d(ji,jj) + (fprd(ji,jj)  * zphd(ji,jj) * fse3t(ji,jj,jk))
                   ENDIF
                   IF( med_diag%MPD%dgsave ) THEN
-                      fdpd2d(ji,jj) = fdpd2d(ji,jj) + (fdpd         * fthk) 
+                      fdpd2d(ji,jj) = fdpd2d(ji,jj) + (fdpd(ji,jj)         * fse3t(ji,jj,jk)) 
                   ENDIF
                   !  IF( med_diag%DSED%dgsave ) THEN
@@ -4056,32 +4030,32 @@
                   !  ENDIF
                   IF( med_diag%OPAL%dgsave ) THEN
-                      fprds2d(ji,jj) = fprds2d(ji,jj) + (fprds * zpds * fthk) 
+                      fprds2d(ji,jj) = fprds2d(ji,jj) + (fprds(ji,jj) * zpds(ji,jj) * fse3t(ji,jj,jk)) 
                   ENDIF
                   IF( med_diag%OPALDISS%dgsave ) THEN
-                      fsdiss2d(ji,jj) = fsdiss2d(ji,jj) + (fsdiss  * fthk)  
+                      fsdiss2d(ji,jj) = fsdiss2d(ji,jj) + (fsdiss(ji,jj)  * fse3t(ji,jj,jk))  
                   ENDIF
                   IF( med_diag%GMIPn%dgsave ) THEN
-                      fgmipn2d(ji,jj) = fgmipn2d(ji,jj) + (fgmipn  * fthk) 
+                      fgmipn2d(ji,jj) = fgmipn2d(ji,jj) + (fgmipn(ji,jj)  * fse3t(ji,jj,jk)) 
                   ENDIF
                   IF( med_diag%GMID%dgsave ) THEN
-                      fgmid2d(ji,jj) = fgmid2d(ji,jj) + (fgmid   * fthk) 
+                      fgmid2d(ji,jj) = fgmid2d(ji,jj) + (fgmid(ji,jj)   * fse3t(ji,jj,jk)) 
                   ENDIF
                   IF( med_diag%MZMI%dgsave ) THEN
-                      fdzmi2d(ji,jj) = fdzmi2d(ji,jj) + (fdzmi   * fthk) 
+                      fdzmi2d(ji,jj) = fdzmi2d(ji,jj) + (fdzmi(ji,jj)   * fse3t(ji,jj,jk)) 
                   ENDIF
                   IF( med_diag%GMEPN%dgsave ) THEN
-                      fgmepn2d(ji,jj) = fgmepn2d(ji,jj) + (fgmepn  * fthk)
+                      fgmepn2d(ji,jj) = fgmepn2d(ji,jj) + (fgmepn(ji,jj)  * fse3t(ji,jj,jk))
                   ENDIF
                   IF( med_diag%GMEPD%dgsave ) THEN
-                      fgmepd2d(ji,jj) = fgmepd2d(ji,jj) + (fgmepd  * fthk) 
+                      fgmepd2d(ji,jj) = fgmepd2d(ji,jj) + (fgmepd(ji,jj)  * fse3t(ji,jj,jk)) 
                   ENDIF
                   IF( med_diag%GMEZMI%dgsave ) THEN
-                      fgmezmi2d(ji,jj) = fgmezmi2d(ji,jj) + (fgmezmi * fthk) 
+                      fgmezmi2d(ji,jj) = fgmezmi2d(ji,jj) + (fgmezmi(ji,jj) * fse3t(ji,jj,jk)) 
                   ENDIF
                   IF( med_diag%GMED%dgsave ) THEN
-                      fgmed2d(ji,jj) = fgmed2d(ji,jj) + (fgmed   * fthk) 
+                      fgmed2d(ji,jj) = fgmed2d(ji,jj) + (fgmed(ji,jj)   * fse3t(ji,jj,jk)) 
                   ENDIF
                   IF( med_diag%MZME%dgsave ) THEN
-                      fdzme2d(ji,jj) = fdzme2d(ji,jj) + (fdzme   * fthk) 
+                      fdzme2d(ji,jj) = fdzme2d(ji,jj) + (fdzme(ji,jj)   * fse3t(ji,jj,jk)) 
                   ENDIF
                   !  IF( med_diag%DEXP%dgsave ) THEN
